
error_exit()
{
    MSG=$1
    echo $MSG 1>&2
    exit 1
}

del_dirs()
{
  #rm -rf ext/lib/$TAG_DIR/*_$MODEL.lib
  rm -rf ext
  rm -rf obj
  rm -rf exe/$MODEL/$TAG_DIR
  if  [ -f "lib/$TAG_DIR/lib_$MODEL.lib" ]
  then
     rm lib/$TAG_DIR/lib_$MODEL.lib
  fi
}

copy_make()
{
  rm -rf make/*
  cp -r $WMAKE_DIR/* make/
  mkdir -p make_config
  rm -rf make_config/*
  cp -r $MAKE_CONFIG_DIR/* make_config/
}

#expat compile#
compile_expat()
{
    cd $TP_REPO_DIR/$EXPAT_REPO_NAME
    del_dirs $MODEL
    copy_make
    cd $TP_REPO_DIR/$EXPAT_REPO_NAME/buildsystem
    python ../make/tools/apache-ivy/ivygen.py --config ivygen.ini
    cd $TP_REPO_DIR/$EXPAT_REPO_NAME/mkspec/dll
    wmake $MODEL $TAG
    echo $(pwd)
    if [ $? -ne 0 ]; then
       error_exit "Expat compilation failed for $MODEL"
    fi
    
}


## zlib compile ##
compile_zlib()
{
    cd $TP_REPO_DIR/$ZLIB_REPO_NAME
    del_dirs $MODEL
    copy_make
    cd $TP_REPO_DIR/$ZLIB_REPO_NAME/buildsystem
    python ../make/tools/apache-ivy/ivygen.py --config ivygen.ini
    cd $TP_REPO_DIR/$ZLIB_REPO_NAME/mkspec
    wmake $MODEL $TAG
    if [ $? -ne 0 ]; then
       error_exit "Zlib compilation failed for $MODEL"
    fi
}

### openssl compile ####
compile_openssl()
{
    cd $TP_REPO_DIR/$OPENSSL_REPO_NAME
    del_dirs $MODEL
    copy_make
    cd $TP_REPO_DIR/$OPENSSL_REPO_NAME/buildsystem
    python ../make/tools/apache-ivy/ivygen.py --config ivygen.ini

    cd $TP_REPO_DIR/$OPENSSL_REPO_NAME/mkspec/
    chmod 770 ./before_import.sh
    ./before_import.sh

    mkdir -p $TP_REPO_DIR/$OPENSSL_REPO_NAME/ext/lib/$TAG_DIR
    cd $TP_REPO_DIR/$OPENSSL_REPO_NAME/ext/lib/$TAG_DIR
    rm zlib_$MODEL.lib
    ln -s $TP_REPO_DIR/$ZLIB_REPO_NAME/lib/$TAG_DIR/zlib_$MODEL.lib zlib_$MODEL.lib
    
    cd $TP_REPO_DIR/$OPENSSL_REPO_NAME/mkspec/ssl
    wmake $MODEL $TAG
    if [ $? -ne 0 ]; then
       error_exit "Openssl compilation failed for $MODEL"
    fi
    
    cd $TP_REPO_DIR/$OPENSSL_REPO_NAME/mkspec/ssl/static
    wmake $MODEL $TAG
    if [ $? -ne 0 ]; then
       error_exit "Openssl compilation failed for $MODEL"
    fi
    
    cd $TP_REPO_DIR/$OPENSSL_REPO_NAME/mkspec/crypto/static
    wmake $MODEL $TAG
    if [ $? -ne 0 ]; then
       error_exit "Openssl compilation failed for $MODEL"
    fi
}


### libpng compile ###
compile_libpng()
{
    cd $TP_REPO_DIR/$LIBPNG_REPO_NAME
    del_dirs $MODEL
    copy_make
    cd $TP_REPO_DIR/$LIBPNG_REPO_NAME/buildsystem
    python ../make/tools/apache-ivy/ivygen.py --config ivygen.ini
    cd $TP_REPO_DIR/$LIBPNG_REPO_NAME/libpng
    wmake $MODEL $TAG
    if [ $? -ne 0 ]; then
       error_exit "Libpng compilation failed for $MODEL"
    fi
}

### oniguruma compile ###
compile_oniguruma()
{
   cd $TP_REPO_DIR/oniguruma
   del_dirs $MODEL
   copy_make
  
   cd $TP_REPO_DIR/$ONIG_REPO_NAME/buildsystem
   python ../make/tools/apache-ivy/ivygen.py --config ivygen.ini
 
   cd $TP_REPO_DIR/$ONIG_REPO_NAME/oniguruma/dll
   wmake $MODEL $TAG
   if [ $? -ne 0 ]; then
     error_exit "Oniguruma compilation failed for $MODEL"
   fi
   
   cd $TP_REPO_DIR/$ONIG_REPO_NAME/oniguruma/static
   wmake $MODEL $TAG
   if [ $? -ne 0 ]; then
     error_exit "Oniguruma compilation failed for $MODEL"
   fi
}

## ulxmlrpccp compile ###
compile_ulxmlrpcpp()
{
   cd $TP_REPO_DIR/ulxmlrpcpp
   del_dirs $MODEL
   copy_make
   
   cd $TP_REPO_DIR/ulxmlrpcpp/buildsystem
   python ../make/tools/apache-ivy/ivygen.py --config ivygen.ini
   
   mkdir -p $TP_REPO_DIR/ulxmlrpcpp/ext/lib/$TAG_DIR
   cd $TP_REPO_DIR/ulxmlrpcpp/ext/lib/$TAG_DIR
   $BUILD_SCRIPT_DIR/create_ssl_zlib_soft_links.sh $MODEL
   rm expat_$MODEL.lib
   ln -s $TP_REPO_DIR/expat/lib/$TAG_DIR/expat_$MODEL.lib
   cd $TP_REPO_DIR/ulxmlrpcpp/mkspec
   wmake $MODEL $TAG -sn
   if [ $? -ne 0 ]; then
    error_exit "ulxmlrpcpp compilation failed for $MODEL"
   fi
}

##sqlite  compile ##
compile_sqlite()
{
   cd $TP_REPO_DIR/$SQLITE_REPO_NAME
   del_dirs $MODEL
   copy_make
   cd $TP_REPO_DIR/$SQLITE_REPO_NAME/buildsystem
   python ../make/tools/apache-ivy/ivygen.py --config ivygen.ini

   cd $TP_REPO_DIR/$SQLITE_REPO_NAME/mkspecs/dll
   wmake $MODEL $TAG
   if [ $? -ne 0 ]; then
     error_exit "SQLITE compilation failed for $MODEL"
   fi

}

### libevent compile ###
compile_libevent()
{
  cd $TP_REPO_DIR/$LIBEVENT_REPO_NAME/
  del_dirs $MODEL
  copy_make
  cd $TP_REPO_DIR/$LIBEVENT_REPO_NAME/buildsystem
  python ../make/tools/apache-ivy/ivygen.py --config ivygen.ini
 
  mkdir -p $TP_REPO_DIR/$LIBEVENT_REPO_NAME/ext/lib/$TAG_DIR
  cd $TP_REPO_DIR/$LIBEVENT_REPO_NAME/ext/lib/$TAG_DIR
  $BUILD_SCRIPT_DIR/create_ssl_zlib_soft_links.sh $MODEL
  cd $TP_REPO_DIR/$LIBEVENT_REPO_NAME/ext/lib/$TAG_DIR
  $BUILD_SCRIPT_DIR/create_ssl_zlib_soft_links.sh $MODEL
  
  cd $TP_REPO_DIR/$LIBEVENT_REPO_NAME/mkspec/dynamic
  wmake $MODEL $TAG
  if [ $? -ne 0 ]; then
    error_exit "Libevent compilation failed for $MODEL"
  fi
  
  cd $TP_REPO_DIR/$LIBEVENT_REPO_NAME/mkspec/static
  wmake $MODEL $TAG
  if [ $? -ne 0 ]; then
    error_exit "Libevent compilation failed for $MODEL"
  fi
}

### libevhtp compile ###
compile_libevhtp()
{
   cd $TP_REPO_DIR/$LIBEVHTP_REPO_NAME
   del_dirs $MODEL
   copy_make
   cd $TP_REPO_DIR/$LIBEVHTP_REPO_NAME/buildsystem
   python ../make/tools/apache-ivy/ivygen.py --config ivygen.ini

   cd $TP_REPO_DIR/$LIBEVHTP_REPO_NAME/libevhtp/static
   wmake $MODEL $TAG
   if [ $? -ne 0 ]; then
     error_exit "Libevhtp compilation failed for $MODEL"
   fi
}

### icu compile ###
compile_icu()
{
   cd $TP_REPO_DIR/$ICU_REPO_NAME
   del_dirs $MODEL
   copy_make

   cd $TP_REPO_DIR/$ICU_REPO_NAME/buildsystem
   python ../make/tools/apache-ivy/ivygen.py --config ivygen.ini
   
   cd $TP_REPO_DIR/$ICU_REPO_NAME/icu/dll
   wmake $MODEL $TAG
   if [ $TAG == "release=nop" ]; then 
     cp $TP_REPO_DIR/$ICU_REPO_NAME/obj/icudt/$MODEL/$TAG_DIR/nop/dll/icudt38.dll $TP_REPO_DIR/$ICU_REPO_NAME/exe/$MODEL/$TAG_DIR/
   elif [ $TAG == "release=0" ]; then 
     cp $TP_REPO_DIR/$ICU_REPO_NAME/obj/icudt/$MODEL/$TAG_DIR/0/dll/icudt38.dll $TP_REPO_DIR/$ICU_REPO_NAME/exe/$MODEL/$TAG_DIR/
   fi
   #if [ $? -ne 0 ]; then
   #  error_exit "ICU compilation failed for $MODEL"
   #fi
   
   cd $TP_REPO_DIR/$ICU_REPO_NAME/icu_supp
   wmake $MODEL $TAG
   #if [ $? -ne 0 ]; then
   #  error_exit "ICU compilation failed for $MODEL"
   #fi
   
   cd $TP_REPO_DIR/$ICU_REPO_NAME/icu/data
   wmake $MODEL $TAG
   #if [ $? -ne 0 ]; then
   #  error_exit "ICU compilation failed for $MODEL"
   #fi
   
   cd $TP_REPO_DIR/$ICU_REPO_NAME/icu/dll/stubdata
   wmake $MODEL $TAG
   #if [ $? -ne 0 ]; then
   #  error_exit "ICU compilation failed for $MODEL"
   #fi
  
   cd $TP_REPO_DIR/$ICU_REPO_NAME/icu/dos
   wmake $MODEL $TAG
   #if [ $? -ne 0 ]; then
   #  error_exit "ICU compilation failed for $MODEL"
   #fi
}


## logging logging ##
compile_logging()
{
  cd $TP_REPO_DIR/$LOGGING_REPO_NAME/
  del_dirs $MODEL
  copy_make
  cd $TP_REPO_DIR/$LOGGING_REPO_NAME/buildsystem
  python ../make/tools/apache-ivy/ivygen.py --config ivygen.ini

  mkdir -p $TP_REPO_DIR/$LOGGING_REPO_NAME/ext/lib/$TAG_DIR  
  cd $TP_REPO_DIR/$LOGGING_REPO_NAME/ext/lib/$TAG_DIR
  $BUILD_SCRIPT_DIR/create_ssl_zlib_soft_links.sh $MODEL

  mkdir -p $TP_REPO_DIR/$LOGGING_REPO_NAME/ext/include
  cd $TP_REPO_DIR/$LOGGING_REPO_NAME/ext/include
  #cp -r $TP_REPO_DIR/acronis-http/ext/include/unicode .
  cp -r $HOME_DIR/unicode .
  
  cd $TP_REPO_DIR/$LOGGING_REPO_NAME/logging/dll
  wmake $MODEL $TAG
  if [ $? -ne 0 ]; then
    error_exit "logging compilation failed for $MODEL"
  fi
  
  cd $TP_REPO_DIR/$LOGGING_REPO_NAME/logging/static
  wmake $MODEL $TAG
  if [ $? -ne 0 ]; then
    error_exit "logging compilation failed for $MODEL"
  fi
  
  cd $TP_REPO_DIR/$LOGGING_REPO_NAME/logging/stub
  wmake $MODEL $TAG
  if [ $? -ne 0 ]; then
    error_exit "logging compilation failed for $MODEL"
  fi
}


### http compile ###
compile_http()
{
   cd $TP_REPO_DIR/$HTTP_REPO_NAME
   del_dirs $MODEL
   copy_make
   cd $TP_REPO_DIR/$HTTP_REPO_NAME/buildsystem
   python ../make/tools/apache-ivy/ivygen.py --config ivygen.ini

   mkdir -p $TP_REPO_DIR/$HTTP_REPO_NAME/ext/lib/$TAG_DIR
   cd $TP_REPO_DIR/$HTTP_REPO_NAME/ext/lib/$TAG_DIR
   
   $BUILD_SCRIPT_DIR/create_ssl_zlib_soft_links.sh $MODEL
   $BUILD_SCRIPT_DIR/create_onig_soft_links.sh $MODEL
   $BUILD_SCRIPT_DIR/create_icu_soft_links.sh $MODEL
   $BUILD_SCRIPT_DIR/create_logging_soft_links.sh $MODEL
   $BUILD_SCRIPT_DIR/create_libeve_soft_links.sh $MODEL
   cd $TP_REPO_DIR/$HTTP_REPO_NAME/http/dll
   wmake $MODEL $TAG
   if [ $? -ne 0 ]; then
     error_exit "Http compilation failed for $MODEL"
   fi
}

## pcs compile ##
compile_pcs()
{
   cd $TP_REPO_DIR/$PCS_REPO_NAME
   del_dirs $MODEL
   copy_make

   mkdir -p $TP_REPO_DIR/$PCS_REPO_NAME/ext/lib/$TAG_DIR
   cd $TP_REPO_DIR/$PCS_REPO_NAME/ext/lib/$TAG_DIR
   $BUILD_SCRIPT_DIR/create_ssl_zlib_soft_links.sh $MODEL
   ln -sf ~/nasbuild/zstdlibs/libzstd_$MODEL.so.1.3.1 zstd_$MODEL.lib
  

   cd $TP_REPO_DIR/$PCS_REPO_NAME/pstorage-core/pcs/build.acronis/libpcs_io
   wmake $MODEL $TAG
   if [ $? -ne 0 ]; then
     error_exit "PCS compilation failed for $MODEL"
   fi
   
   cd $TP_REPO_DIR/$PCS_REPO_NAME/pstorage-core/pcs/build.acronis/libpcs_io/static
   wmake $MODEL $TAG
   if [ $? -ne 0 ]; then
     error_exit "PCS compilation failed for $MODEL"
   fi
   
   cd $TP_REPO_DIR/$PCS_REPO_NAME/pstorage-core/pcs/build.acronis/mcp
   wmake $MODEL $TAG
   if [ $? -ne 0 ]; then
     error_exit "PCS compilation failed for $MODEL"
   fi
}

## archive3 compile ##
compile_archive3()
{
   cd $TP_REPO_DIR/$ARCHIVE3_REPO_NAME
   del_dirs $MODEL
   copy_make
   mkdir -p $TP_REPO_DIR/$ARCHIVE3_REPO_NAME/ext/lib/$TAG_DIR
   cd $TP_REPO_DIR/$ARCHIVE3_REPO_NAME/ext/lib/$TAG_DIR
   $BUILD_SCRIPT_DIR/create_ssl_zlib_soft_links.sh $MODEL
   $BUILD_SCRIPT_DIR/create_pcs_io_soft_links.sh $MODEL
   ln -sf ~/nasbuild/zstdlibs/libzstd_$MODEL.so.1.3.1 zstd_$MODEL.lib
   
   cd $TP_REPO_DIR/$ARCHIVE3_REPO_NAME/buildsystem/libarchive3
   wmake $MODEL $TAG
   if [ $? -ne 0 ]; then
     error_exit "Archive3 compilation failed for $MODEL"
   fi
}

##curl compile ##
compile_curl()
{
   cd $TP_REPO_DIR/$CURL_REPO_NAME
   del_dirs $MODEL
   copy_make
   cd $TP_REPO_DIR/$CURL_REPO_NAME/buildsystem
   python ../make/tools/apache-ivy/ivygen.py --config ivygen.ini

   mkdir -p $TP_REPO_DIR/$CURL_REPO_NAME/ext/lib/$TAG_DIR
   cd $TP_REPO_DIR/$CURL_REPO_NAME/ext/lib/$TAG_DIR
   $BUILD_SCRIPT_DIR/create_ssl_zlib_soft_links.sh $MODEL

   cd $TP_REPO_DIR/$CURL_REPO_NAME/mkspec
   wmake $MODEL $TAG
   if [ $? -ne 0 ]; then
      error_exit "Curl compilation failed for $MODEL"
   fi
   
   cd $TP_REPO_DIR/$CURL_REPO_NAME/mkspec/static
   wmake $MODEL $TAG
   if [ $? -ne 0 ]; then
      error_exit "Curl compilation failed for $MODEL"
   fi
}

##curlpp compile ##
compile_curlpp()
{
   cd $TP_REPO_DIR/$CURLPP_REPO_NAME
   #del_dirs $MODEL
   #copy_make
   cd $TP_REPO_DIR/$CURLPP_REPO_NAME/buildsystem
   python ../make/tools/apache-ivy/ivygen.py --config ivygen.ini

   mkdir -p $TP_REPO_DIR/$CURLPP_REPO_NAME/ext/lib/$TAG_DIR
   cd $TP_REPO_DIR/$CURLPP_REPO_NAME/ext/lib/$TAG_DIR
   $BUILD_SCRIPT_DIR/create_ssl_zlib_soft_links.sh $MODEL

   mkdir -p $TP_REPO_DIR/$CURLPP_REPO_NAME/ext/include/curl/
   #hack for curl
   cp $SRC_DIR/curlbuild.h $TP_REPO_DIR/$CURLPP_REPO_NAME/ext/include/curl/curlbuild.h
   if [ $? -ne 0 ]; then
      error_exit "Curlpp compilation failed for $MODEL. Please compile curl and
get curlbuild.h file"
   fi
   
   cd $TP_REPO_DIR/$CURLPP_REPO_NAME/mkspec
   wmake $MODEL $TAG
   if [ $? -ne 0 ]; then
      error_exit "Curlpp compilation failed for $MODEL"
   fi
}

##jsoncpp  compile ##
compile_jsoncpp()
{
   cd $TP_REPO_DIR/$JSON_REPO_NAME
   del_dirs $MODEL
   copy_make
   cd $TP_REPO_DIR/$JSON_REPO_NAME/buildsystem
   python ../make/tools/apache-ivy/ivygen.py --config ivygen.ini

   cd $TP_REPO_DIR/$JSON_REPO_NAME/mkspec
   wmake $MODEL $TAG
   if [ $? -ne 0 ]; then
      error_exit "Jsoncpp compilation failed for $MODEL"
   fi
}

main()
{
  compile_jsoncpp

  #compile_expat 

  #compile_zlib 
   
  #compile_openssl 
   
  #compile_libpng 
  
  #compile_oniguruma 
  
  #compile_ulxmlrpcpp 
  
  #compile_sqlite

  #compile_curl
  
  #compile_curlpp 
  
  #compile_libevent 
   
  #compile_libevhtp 
   
  #compile_icu 
   
  #compile_logging 
   
  #compile_http 
   
  #compile_pcs 
   
  #compile_archive3 
}

main 
