
error_exit()
{
    MSG=$1
    echo $MSG 1>&2
    exit 1
}

configure_extra() 
{
  TRIPLET=$1
  VENDOR=$2
  if [ -z $VENDOR ]; then
    /bin/ln -sf $SRC_DIR/extra/$TRIPLET/extra $CYGWIN_ROOT/opt/crosstool/$TRIPLET/extra
  else 
    /bin/ln -sf $SRC_DIR/extra/$VENDOR/$TRIPLET/extra $CYGWIN_ROOT/opt/crosstool/$TRIPLET/extra
  fi
  
}

## setup basic commands
setup_common_cmds()
{
  rm -rf $CYGWIN_ROOT/bin && mkdir -p $CYGWIN_ROOT/bin
  cd $CYGWIN_ROOT/bin
  /bin/ln -s /usr/bin/sort sort
  /bin/ln -s /bin/mv mv
  /bin/ln -s /bin/bash bash
  /bin/ln -s /bin/ls ls
}

## common toolchain stuff ##
setup_toolchain_dirs()
{
  setup_common_cmds
  TRIPLET=$1
  rm -rf $CYGWIN_ROOT/opt/crosstool/$TRIPLET
  mkdir -p $CYGWIN_ROOT/opt/crosstool/$TRIPLET/gcc-5.3.0-glibc-2.3.4/bin
}

## linux compiler setting ##
configure_linux_toolchain()
{
  TRIPLET=$1
  setup_toolchain_dirs $TRIPLET
  cd $CYGWIN_ROOT/opt/crosstool/$TRIPLET/gcc-5.3.0-glibc-2.3.4/bin
  /bin/ln -s /usr/bin/gcc $TRIPLET-gcc.exe
  /bin/ln -s /usr/bin/g++ $TRIPLET-g++.exe
  /bin/ln -s /usr/bin/ar  $TRIPLET-ar.exe
  /bin/ln -s /usr/bin/objcopy $TRIPLET-objcopy.exe
  /bin/ln -s /usr/bin/strip  $TRIPLET-strip.exe
  configure_extra $TRIPLET
  echo "linux $TRIPLET toolchain configured."
}

## synoarmv7 compiler setting ##
configure_synoarmv7_toolchain()
{
  TRIPLET=$1
  setup_toolchain_dirs $TRIPLET
  cd $CYGWIN_ROOT/opt/crosstool/$TRIPLET/gcc-5.3.0-glibc-2.3.4/bin
  /bin/ln -s $SYNO_TOOLCHAIN_LOCATION/$TRIPLET/bin/$TRIPLET-gcc $TRIPLET-gcc.exe
  /bin/ln -s $SYNO_TOOLCHAIN_LOCATION/$TRIPLET/bin/$TRIPLET-g++ $TRIPLET-g++.exe
  /bin/ln -s $SYNO_TOOLCHAIN_LOCATION/$TRIPLET/bin/$TRIPLET-ar  $TRIPLET-ar.exe
  /bin/ln -s $SYNO_TOOLCHAIN_LOCATION/$TRIPLET/bin/$TRIPLET-objcopy $TRIPLET-objcopy.exe
  /bin/ln -s $SYNO_TOOLCHAIN_LOCATION/$TRIPLET/bin/$TRIPLET-strip $TRIPLET-strip.exe
  configure_extra $TRIPLET synology
  echo "synoarmv7 $TRIPLET toolchain configured."
}

## synoa64 compiler setting ##
configure_synoa64_toolchain()
{
  TRIPLET=$1
  setup_toolchain_dirs $TRIPLET
  cd $CYGWIN_ROOT/opt/crosstool/$TRIPLET/gcc-5.3.0-glibc-2.3.4/bin
  /bin/ln -s $SYNO_TOOLCHAIN_LOCATION/$TRIPLET/bin/$TRIPLET-gcc $TRIPLET-gcc.exe
  /bin/ln -s $SYNO_TOOLCHAIN_LOCATION/$TRIPLET/bin/$TRIPLET-g++ $TRIPLET-g++.exe
  /bin/ln -s $SYNO_TOOLCHAIN_LOCATION/$TRIPLET/bin/$TRIPLET-ar  $TRIPLET-ar.exe
  /bin/ln -s $SYNO_TOOLCHAIN_LOCATION/$TRIPLET/bin/$TRIPLET-objcopy $TRIPLET-objcopy.exe
  /bin/ln -s $SYNO_TOOLCHAIN_LOCATION/$TRIPLET/bin/$TRIPLET-strip $TRIPLET-strip.exe
  configure_extra $TRIPLET synology
  echo "synoa64 $TRIPLET toolchain configured."
}

## qnap and qnap64 common toolchain links ##
setup_qnaps_toolchain_links_helper()
{
  TRIPLET=$1
  cd $CYGWIN_ROOT/opt/crosstool/$TRIPLET/gcc-5.3.0-glibc-2.3.4/bin
  /bin/ln -s $QNAP_TOOLCHAIN_LOCATION/$TRIPLET/cross-tools/bin/$TRIPLET-gcc $TRIPLET-gcc.exe
  /bin/ln -s $QNAP_TOOLCHAIN_LOCATION/$TRIPLET/cross-tools/bin/$TRIPLET-g++ $TRIPLET-g++.exe
  /bin/ln -s $QNAP_TOOLCHAIN_LOCATION/$TRIPLET/cross-tools/bin/$TRIPLET-ar  $TRIPLET-ar.exe
  /bin/ln -s $QNAP_TOOLCHAIN_LOCATION/$TRIPLET/cross-tools/bin/$TRIPLET-objcopy $TRIPLET-objcopy.exe
  /bin/ln -s $QNAP_TOOLCHAIN_LOCATION/$TRIPLET/cross-tools/bin/$TRIPLET-strip $TRIPLET-strip.exe
}

## qnap compiler setting ##
configure_qnap_toolchain()
{
  TRIPLET=$1
  setup_toolchain_dirs $TRIPLET
  setup_qnaps_toolchain_links_helper $TRIPLET
  configure_extra $TRIPLET qnap
  echo "qnap $TRIPLET toolchain configured."
}

## qnapa64 compiler setting ##
configure_qnapa64_toolchain()
{
  TRIPLET=$1
  setup_toolchain_dirs $TRIPLET
  setup_qnaps_toolchain_links_helper $TRIPLET 
  configure_extra $TRIPLET qnap
  echo "qnapa64 $TRIPLET toolchain configured."
}

## qnaparmv7 compiler setting ##
configure_qnaparmv7_toolchain()
{
  TRIPLET=$1
  setup_toolchain_dirs $TRIPLET
  cd $CYGWIN_ROOT/opt/crosstool/$TRIPLET/gcc-5.3.0-glibc-2.3.4/bin
  #/bin/ln -s $QNAP_TOOLCHAIN_LOCATION/$TRIPLET/bin/$TRIPLET-gcc $TRIPLET-gcc.exe
  #/bin/ln -s $QNAP_TOOLCHAIN_LOCATION/$TRIPLET/bin/$TRIPLET-g++ $TRIPLET-g++.exe
  #/bin/ln -s $QNAP_TOOLCHAIN_LOCATION/$TRIPLET/bin/$TRIPLET-ar  $TRIPLET-ar.exe
  #/bin/ln -s $QNAP_TOOLCHAIN_LOCATION/$TRIPLET/bin/$TRIPLET-objcopy $TRIPLET-objcopy.exe
  #/bin/ln -s $QNAP_TOOLCHAIN_LOCATION/$TRIPLET/bin/$TRIPLET-strip $TRIPLET-strip.exe
  
  /bin/ln -s /opt/cross/qnap/$TRIPLET/bin/$TRIPLET-gcc $TRIPLET-gcc.exe
  /bin/ln -s /opt/cross/qnap/$TRIPLET/bin/$TRIPLET-g++ $TRIPLET-g++.exe
  /bin/ln -s /opt/cross/qnap/$TRIPLET/bin/$TRIPLET-ar  $TRIPLET-ar.exe
  /bin/ln -s /opt/cross/qnap/$TRIPLET/bin/$TRIPLET-objcopy $TRIPLET-objcopy.exe
  /bin/ln -s /opt/cross/qnap/$TRIPLET/bin/$TRIPLET-strip $TRIPLET-strip.exe
  configure_extra $TRIPLET synology
  echo "qnaparmv7 $TRIPLET toolchain configured."
}



main()
{
  echo "Configuring toolchain " 
  x86_64=yes
  if $(uname -m | grep '64'); then
    echo "ARCH: 64-bit"
  else
    echo "ARCH: 32-bit"
    x86_64=no
  fi

  if [ $x86_64 == 'yes' ]; then
    configure_linux_toolchain x86_64-unknown-linux-gnu
  else
    configure_linux_toolchain i686-unknown-linux-gnu
  fi
  
  if [ $MODEL == "lxa64" ]; then
     configure_lxa64_toolchain x86_64-unknown-linux-gnu 
  elif [ $MODEL == "synoarmv7" ]; then
     configure_synoarmv7_toolchain arm-unknown-linux-gnueabi 
  elif [ $MODEL == "synoa64" ]; then
     configure_synoa64_toolchain x86_64-pc-linux-gnu
  elif [ $MODEL == "qnap" ]; then
     configure_qnap_toolchain i686-QNAP-linux-gnu
  elif [ $MODEL == "qnapa64" ]; then
     configure_qnapa64_toolchain x86_64-QNAP-linux-gnu
  elif [ $MODEL == "qnaparmv7" ]; then
     configure_qnaparmv7_toolchain arm-unknown-linux-gnueabi
  else
   error_exit "Invalid $MODEL. Exiting..."
  fi
}

main
