#!/bin/sh

#WRM server and Status server configuration

#/usr/local/Acronis
#It contains 2 folders
#-----MobileBackupServer
#----------Conf
#----------AcronisMobileBackupData  ---> /pkgVolume/AcronisMobileBackupData
#-----TrueImageHome
#----------Database
#----------Logs\mobile_backup_status_server

#TrueImageHome is automatically created by status server


ACRONIS_DIR=$SYNOPKG_PKGDEST_VOL/Acronis
PKG_DATA_DIR=$ACRONIS_DIR/MobileBackupServer
TARGET=$SYNOPKG_PKGDEST

#setup local back data location
setup_local_path()
{
  LOCAL_PATH=$PKG_DATA_DIR
  /bin/mkdir -p $LOCAL_PATH
  /bin/rm  -rf /usr/local/Acronis
  /bin/ln -sf $ACRONIS_DIR /usr/local/Acronis
}

#setup config path location and copy files
setup_wrm_conf_path()
{
   CONFIG_PATH=$PKG_DATA_DIR/Conf
   /bin/mkdir -p $CONFIG_PATH
   /bin/cp $TARGET/bin/WRM.conf $CONFIG_PATH
   /bin/cp $TARGET/bin/status_server.conf $CONFIG_PATH
   /bin/cp $TARGET/bin/priv $CONFIG_PATH
   /bin/cp $TARGET/bin/pub $CONFIG_PATH
}

#remove package all files (should be used during uninstall
remove_pkg_files()
{
   /bin/rm -rf /usr/local/Acronis
   /bin/rm -rf $ACRONIS_DIR
}

#function should be used during package upgrade operation
#during upgrade below sequence of events happens
#preupgrade
#preuninst
#postuninst
#preinst
#postinst
#postupgrade
#logic to handle upgrade operation
#----preupgrade, rename all the package top level folders to be treated as
#    backup, otherwise it will be deleted during postuninst operation
#----preuninst, do nothing
#----postuninst, it will remove all the folder, but nothing will happen, as all
#    the files which postinstall tries to delete are renamed
#----preinst, do nothing
#----postinst, this will create all the pkg folders again
#----postupgrade, this is where trick happens, since pkg folders are created in
#    previous stage. It needs to be deleted, and then folders which were renamed in
#    preupgrade stage, need to bring back to normal names again

backup_pkg_files()
{
  /bin/mv $ACRONIS_DIR $ACRONIS_DIR.backup 
}

restore_pkg_files()
{
  /bin/mv $ACRONIS_DIR.backup $ACRONIS_DIR 
}

ensure_pkg_files_exist()
{
  CONFIG_PATH=$PKG_DATA_DIR/Conf 
  if [ ! -f $CONFIG_PATH/WRM.conf ]; then
     return 1
  fi

  if [ ! -f $CONFIG_PATH/status_server.conf ]; then
     return 1
  fi

  if [ ! -f $CONFIG_PATH/priv ]; then
     return 1
  fi

  if [ ! -f $CONFIG_PATH/pub ]; then
     return 1
  fi

  return 0
}
